//+------------------------------------------------------------------+
//|                                                      Stopper.mq4 |
//|                                                         azman818 |
//|                                                    strategy: T68 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

//---- input parameters

extern int     levels=4;
extern double  Lot_1=0.3;
extern double  Lot_Exp=2.00;
extern int     TP=12;
extern int     tpx=0;
extern int     SL=7;
extern int     slx=1;
extern int     Start_Order=0;

extern int     magic=6800;

int            Order_Type=0;

int            slippage=3;
int            spread;
double         price_B;  
double         price_S;
int            level_cnt=0;
double         takeprofit=0;
double         stoploss=0;

int            tick=0;  


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

int start()

{
   int ticket;
   
   tick++;

   if(levels>10) levels=10;

   ticket = Check_Ticket();
   
   if(ticket!=0) level_cnt = Manage_Ticket(ticket);

   Comment ("\n ",
            "\n level = ", level_cnt, "  ( ", Order_Type, " )", "      tick = ", tick,
            "\n ", DoubleToStr(takeprofit,Digits), "   ", DoubleToStr(stoploss,Digits), "   ", ticket);  

   if(ticket==0)
   {
     if(level_cnt!=0)
     { 
       if(level_cnt>=levels) level_cnt = 0;
       if(Order_Type==0)      { Order_Type = 1; level_cnt++; Open_Order_Sell(); }
       else if(Order_Type==1) { Order_Type = 0; level_cnt++; Open_Order_Buy();  }
     }
     if(level_cnt==0)
     {
       if(Start_Order==0) { Order_Type = 0; level_cnt++; Open_Order_Buy(); }
       if(Start_Order==1) { Order_Type = 1; level_cnt++; Open_Order_Sell(); }
     }  
     
   }

   return(0);

}

//+------------------------------------------------------------------+

int Check_Ticket()
{
   int i; int ticket;
   
   ticket = 0;

   for(i=0;i<OrdersTotal();i++)
   {
     if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break; 
     if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic)
     {
       ticket = OrderTicket();
     }  
     if(ticket < 0) ticket = 0;
   }

   return(ticket);

}   

//+------------------------------------------------------------------+

int Manage_Ticket(int ticket)
{ 
   level_cnt=0; 

   ObjectDelete("takeprofit"); ObjectDelete("stoploss");

   OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES);
 
   if(OrderLots()==Lot_1*MathRound(MathPow(Lot_Exp,0))) level_cnt = 1;
   if(OrderLots()==Lot_1*MathRound(MathPow(Lot_Exp,1))) level_cnt = 2;
   if(OrderLots()==Lot_1*MathRound(MathPow(Lot_Exp,2))) level_cnt = 3;
   if(OrderLots()==Lot_1*MathRound(MathPow(Lot_Exp,3))) level_cnt = 4;
   if(OrderLots()==Lot_1*MathRound(MathPow(Lot_Exp,4))) level_cnt = 5;
   if(OrderLots()==Lot_1*MathRound(MathPow(Lot_Exp,5))) level_cnt = 6;
   if(OrderLots()==Lot_1*MathRound(MathPow(Lot_Exp,6))) level_cnt = 7;
   if(OrderLots()==Lot_1*MathRound(MathPow(Lot_Exp,7))) level_cnt = 8;
   if(OrderLots()==Lot_1*MathRound(MathPow(Lot_Exp,8))) level_cnt = 9;
   if(OrderLots()==Lot_1*MathRound(MathPow(Lot_Exp,9))) level_cnt = 10;

   if(OrderType()==0)
   {
     price_B=OrderOpenPrice();

     takeprofit = price_B + (TP+(tpx*(level_cnt-1)))*Point;   
     stoploss = price_B - (SL+(slx*(level_cnt-1)))*Point;

     if(Ask <= stoploss)
     { 
       Alert("!!! STOPLOSS HIT - Level ", level_cnt, "   ", stoploss, "   ", Symbol(), "   ", AccountNumber());
       while(OrdersTotal()!=0) { Close_Order(); }
     }
     if(Bid >= takeprofit)
     {
       Alert("!!! TAKEPROFIT HIT - Level ", level_cnt, "   ", takeprofit, "   ", Symbol(), "   ", AccountNumber());
       while(OrdersTotal()!=0) { Close_Order(); }
       level_cnt = 0;
     }
   }

   if(OrderType()==1)
   {
     price_S=OrderOpenPrice();

     takeprofit = price_S - (TP+(tpx*(level_cnt-1)))*Point;   
     stoploss = price_S + (SL+(slx*(level_cnt-1)))*Point;   

     if(Bid >= stoploss)
     {
       Alert("!!! STOPLOSS HIT - Level ", level_cnt, "   ", stoploss, "   ", Symbol(), "   ", AccountNumber());
       while(OrdersTotal()!=0) { Close_Order(); }
     }
     if(Ask <= takeprofit)
     {
       Alert("!!! TAKEPROFIT HIT - Level ", level_cnt, "   ", takeprofit, "   ", Symbol(), "   ", AccountNumber());
       while(OrdersTotal()!=0) { Close_Order(); }
       level_cnt = 0;
     }
   }

   ObjectCreate("takeprofit", OBJ_HLINE, 0, 0, takeprofit);
   ObjectSet("takeprofit", OBJPROP_COLOR, Blue);
   ObjectSet("takeprofit", OBJPROP_STYLE, STYLE_DOT);
   ObjectCreate("stoploss", OBJ_HLINE, 0, 0, stoploss);
   ObjectSet("stoploss", OBJPROP_COLOR, Red);
   ObjectSet("stoploss", OBJPROP_STYLE, STYLE_DOT);

   return(level_cnt);
}   

//+------------------------------------------------------------------+

void Open_Order_Buy()
{
   int ticket;
   
   price_B=Ask;
   
   while(ticket==0) 
   {
     while(IsTradeAllowed() == false) Sleep(6000);
     ticket = OrderSend(Symbol(),0,Lot_1*MathRound(MathPow(Lot_Exp,level_cnt-1)),price_B,slippage,0,0,NULL,magic,0,Blue);
     if(ticket < 0) ticket = 0;
   }
}

//+------------------------------------------------------------------+

void Open_Order_Sell()
{
   int ticket;
   
   price_S=Ask;
   
   while(ticket==0) 
   {
     while(IsTradeAllowed() == false) Sleep(6000);
     ticket = OrderSend(Symbol(),1,Lot_1*MathRound(MathPow(Lot_Exp,level_cnt-1)),price_S,slippage,0,0,NULL,magic,0,Red);
     if(ticket < 0) ticket = 0;
   }
}

//+------------------------------------------------------------------+

void Close_Order()
{
  for(int i=OrdersTotal()-1;i>=0;i--)
  {
    OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
    if(OrderSymbol()==Symbol() && OrderType()==0)
    {
      while(IsTradeAllowed() == false) Sleep(6000);
      if(OrderClose(OrderTicket(), OrderLots(), Bid, slippage, Blue)==false) continue;
      else Alert("!!! ORDER CLOSE - Level ", level_cnt, "   ", Symbol(), "   ", AccountNumber());
    }   
    if(OrderSymbol()==Symbol() && OrderType()==1)
    {
      while(IsTradeAllowed() == false) Sleep(6000);
      if(OrderClose(OrderTicket(), OrderLots(), Ask, slippage, Red)==false) continue;
      else Alert("!!! ORDER CLOSE - Level ", level_cnt, "   ", Symbol(), "   ", AccountNumber());
    }   
  }
}
//+------------------------------------------------------------------+


